#if defined(__STDC__)
#if defined(VARARGS)
void RestoreErrorMsg(const char *,int);
void ErrorMsg(const char *,int);
#else
void RestoreErrorMsg(const char *,...);
void ErrorMsg(const char *,...);
#endif
#else
void ErrorMsg();
void RestoreErrorMsg();
#endif

typedef enum {ALLKEYWORDS,NOKEYWORDS} KEYTYPES;

typedef enum {TRUTH,FALSITY} BOOLEAN;

typedef enum {NAMEONLY,NUMBERONLY,NAMEANDNUMBER,
                           NAMEANDOID,STRINGONLY} ENTRYTYPE;
typedef struct list {
                        struct list *Next;
                          ENTRYTYPE  Type;
                               char *Name;
                                int  Number;
                        struct list *OID;
                    } LIST;
#if defined(__STDC__)
LIST *newListElement(ENTRYTYPE,char *,int);
LIST *LinkToList(LIST *,LIST *);
char *OIDListToString(LIST *);
#else
LIST *newListElement();
LIST *LinkToList();
char *OIDListToString();
#endif


typedef struct {
                long int Lower;
                long int Upper;
               } PAIR;

typedef enum {NULLTYPE,TICKTYPE,COUNTERTYPE,OBJIDTYPE,
                    GAUGETYPE,IPADDRTYPE,NETWORKTYPE,
                        INTEGERTYPE,RANGEINTEGER,ENUMINTEGER,
                            OCTETTYPE,ITEMTYPE,SEQTYPE,SEQOFTYPE,
                                               STRINGTYPE,TYPENAME} TYPEofTYPE;
typedef struct {
                char *ItemName;
                void *ItemType;
               } NAMEPAIR;

typedef union {
                    PAIR  Range;
                    LIST *EnumList;
                    char *TypeList;
                NAMEPAIR  Names;
                    char *SeqName;
                    char *TypeName;
              } DATAUNION;

typedef struct type {
                        struct type *Next;
                         TYPEofTYPE  Type;
                          DATAUNION  Data;
                    } TYPE;

#if defined(__STDC__)
TYPE *newTypeElement(TYPEofTYPE,char *);
TYPE *LinkToType(TYPE *,TYPE *);
#else
TYPE *newTypeElement();
TYPE *LinkToType();
#endif
