#include <stdio.h>
#include <stdlib.h>

#include "MibCompiler.h"


void PrintList(LIST *p1,int bNewLine)
 {
    for( ; p1; p1 = p1->Next )
        {
            switch(p1->Type)
                {
                    case NAMEONLY   : 
                                      printf(bNewLine ? "%s\n":"%s ",p1->Name);
                                      break;
                    case NUMBERONLY :
                                      printf(bNewLine ? "%d\n":"%d ",p1->Number);
                                      break;
                    case NAMEANDNUMBER :
                                      printf(bNewLine ? "%s(%d)\n":"%s(%d) ",p1->Name,p1->Number);
                                      break;
                }
        }
 }


static char *RangeToString(PAIR range)
 {
    char *pStr;
    static char buf[32];
    if( range.Lower || range.Upper )
             {
                sprintf(buf,"(%d...%d)",range.Lower,range.Upper);
                pStr = buf;
             }
        else pStr = 0;
    return(pStr);
 }

void PrintType(TYPE *p1)
 {
    char *pStr;
    for( ; p1; p1 = p1->Next )
        {
            /*
             * Print out the type info...
             */
            switch(p1->Type)
                {
                    case TICKTYPE :
                            pStr = RangeToString(p1->Data.Range);
                            printf(pStr ? "Tick %s\n" : "Tick\n",pStr);
                            break;
                    case COUNTERTYPE :
                            pStr = RangeToString(p1->Data.Range);
                            printf(pStr ? "Counter %s\n" : "Counter\n",pStr);
                            break;
                    case GAUGETYPE :
                            pStr = RangeToString(p1->Data.Range);
                            printf(pStr ? "Gauge %s\n" : "Gauge\n",pStr);
                            break;
                    case RANGEINTEGER :
                    case INTEGERTYPE :
                            pStr = RangeToString(p1->Data.Range);
                            printf(pStr ? "Integer %s\n":"Integer\n",pStr);
                            break;
                    case OCTETTYPE :
                            pStr = RangeToString(p1->Data.Range);
                            printf(pStr ? "Octet string %s\n" :"Octet string\n",pStr);
                            break;
                    case STRINGTYPE :
                            pStr = RangeToString(p1->Data.Range);
                            printf(pStr ? "String %s\n":"String\n",pStr);
                            break;
                    case OBJIDTYPE :
                            printf("ObjectId\n");
                            break;
                    case IPADDRTYPE :
                            printf("IpAddress\n");
                            break;
                    case NETWORKTYPE :
                            printf("NetworkAddress\n");
                            break;
                    case NULLTYPE :
                            printf("Null\n");
                            break;
                    case ENUMINTEGER :
                            printf("Integer\n");
                            PrintList(p1->Data.EnumList,1);
                            break;
                    case ITEMTYPE :
                            printf("%s ",p1->Data.Names.ItemName);
                            PrintType(p1->Data.Names.ItemType);
                            break;
                    case SEQTYPE :
                            printf("Sequence\n");
                            PrintType((TYPE *)(p1->Data.TypeList));
                            break;
                    case SEQOFTYPE :
                            printf("SequenceOf\n");
                            PrintType((TYPE *)(p1->Data.TypeList));
                            break;
                    case TYPENAME :
                            printf("%s\n",p1->Data.TypeName);
                            break;
                }
        }
 }

