#include <stdio.h>
#if defined(VARARGS)
#include <varargs.h>
#else
#include <stdarg.h>
#endif


#include "MibCompiler.h"


int nErrorCount = 0;

#if defined(VARARGS)
void RestoreErrorMsg(format,va_alist)
const char *format;
va_dcl
#else
void RestoreErrorMsg(const char *format,...)
#endif
 {
    va_list ap;
    /*
     * Convert the format string and arguments to something we can use.
     */
#if defined(VARARGS)
    va_start(ap);
#else
    va_start(ap,char *);
#endif
    (void) vprintf(format,ap);
#if defined(VARARGS)
    va_end(ap)
#else
    va_end(ap);
#endif
    nErrorCount++;
 }


#if defined(VARARGS)
void ErrorMsg(format,va_alist)
const char *format;
va_dcl
#else
void ErrorMsg(const char *format,...)
#endif
 {
    va_list ap;
    /*
     * Convert the format string and arguments to something we can use.
     */
#if defined(VARARGS)
    va_start(ap);
#else
    va_start(ap,char *);
#endif
    (void) vprintf(format,ap);
#if defined(VARARGS)
    va_end(ap)
#else
    va_end(ap);
#endif
 }



